ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.33 by root, Thu Feb 24 07:10:03 2011 UTC vs.
Revision 1.44 by root, Tue Jun 14 07:04:43 2011 UTC

29esac 29esac
30 30
31# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
32# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 34#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LDFLAGS=
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 37
37# some configuration options for modules 38# some configuration options for modules
38PERL_MM_USE_DEFAULT=1 39PERL_MM_USE_DEFAULT=1
40PERL_MM_OPT="MAN1PODS= MAN3PODS="
39#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 41#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
40EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 42EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS 43export PERL_MM_USE_DEFAULT PERL_MM_OPT CORO_INTERFACE EV_EXTRA_DEFS
42 44
43# which extra modules to install by default from CPAN that are 45# which extra modules to install by default from CPAN that are
44# required by mkbundle 46# required by mkbundle
45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 47STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
46 48
47# which extra modules you might want to install 49# which extra modules you might want to install
48EXTRA_MODULES="" 50EXTRA_MODULES=""
49 51
50# overridable functions 52# overridable functions
51preconfigure() { : ; } 53preconfigure() { : ; }
54patchconfig() { : ; }
52postconfigure() { : ; } 55postconfigure() { : ; }
53postbuild() { : ; } 56postbuild() { : ; }
54postinstall() { : ; } 57postinstall() { : ; }
55 58
56# now source user config, if any 59# now source user config, if any
63fi 66fi
64 67
65############################################################################# 68#############################################################################
66# support 69# support
67 70
68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 71PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
70 72
71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 73unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
74unset PERL_MB_OPT
72LC_ALL=C; export LC_ALL # just to be on the safe side 75LC_ALL=C; export LC_ALL # just to be on the safe side
76
77# prepend PATH - not required by staticperl itself, but might make
78# life easier when working in e.g. "staticperl cpan / look"
79PATH="$PERL_PREFIX/perl/bin:$PATH"
73 80
74# set version in a way that Makefile.PL can extract 81# set version in a way that Makefile.PL can extract
75VERSION=VERSION; eval \ 82VERSION=VERSION; eval \
76$VERSION="1.1" 83$VERSION="1.31"
77 84
78BZ2=bz2 85BZ2=bz2
79BZIP2=bzip2 86BZIP2=bzip2
80 87
81fatal() { 88fatal() {
149 verblock <<EOF 156 verblock <<EOF
150downloading perl 157downloading perl
151to manually download perl yourself, place 158to manually download perl yourself, place
152perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 159perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
153trying $URL 160trying $URL
161
162either curl or wget is required for automatic download.
163curl is tried first, then wget.
154EOF 164EOF
155 165
156 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 166 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
157 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 167 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
158 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 168 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
165unpacking perl 175unpacking perl
166EOF 176EOF
167 177
168 mkdir -p unpack 178 mkdir -p unpack
169 rm -rf unpack/perl-$PERL_VERSION 179 rm -rf unpack/perl-$PERL_VERSION
170 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | tar xfC - unpack \ 180 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | ( cd unpack && tar xf - ) \
171 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking" 181 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
172 chmod -R u+w unpack/perl-$PERL_VERSION 182 chmod -R u+w unpack/perl-$PERL_VERSION
173 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 183 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
174 rmdir -p unpack 184 rmdir -p unpack
175 fi 185 fi
227 237
228 # I hate them for this 238 # I hate them for this
229 grep -q -- -fstack-protector Configure && \ 239 grep -q -- -fstack-protector Configure && \
230 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 240 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
231 241
232 preconfigure 242 # what did that bloke think
243 grep -q -- usedl=.define hints/darwin.sh && \
244 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
245
246 preconfigure || fatal "preconfigure hook failed"
233 247
234# trace configure \ 248# trace configure \
235 sh Configure -Duselargefiles \ 249 sh Configure -Duselargefiles \
236 -Uuse64bitint \ 250 -Uuse64bitint \
237 -Dusemymalloc=n \ 251 -Dusemymalloc=n \
269 sedreplace ' 283 sedreplace '
270 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 284 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
271 s/ *-fno-stack-protector */ /g 285 s/ *-fno-stack-protector */ /g
272 ' config.sh 286 ' config.sh
273 287
288 patchconfig || fatal "patchconfig hook failed"
289
274 sh Configure -S || fatal "Configure -S failed" 290 sh Configure -S || fatal "Configure -S failed"
275 291
276 postconfigure || fatal "postconfigure hook failed" 292 postconfigure || fatal "postconfigure hook failed"
277 293
278 touch staticstamp.configure 294 touch staticstamp.configure
295}
296
297write_shellscript() {
298 {
299 echo "#!/bin/sh"
300 echo "STATICPERL=\"$STATICPERL\""
301 echo "PERL_PREFIX=\"$PERL_PREFIX\""
302 echo "MAKE=\"$MAKE\""
303 cat
304 } >"$PERL_PREFIX/bin/$1"
305 chmod 755 "$PERL_PREFIX/bin/$1"
279} 306}
280 307
281build() { 308build() {
282 configure 309 configure
283 310
304EOF 331EOF
305 332
306 ln -sf "perl/bin/" "$STATICPERL/bin" 333 ln -sf "perl/bin/" "$STATICPERL/bin"
307 ln -sf "perl/lib/" "$STATICPERL/lib" 334 ln -sf "perl/lib/" "$STATICPERL/lib"
308 335
336 mkdir "$STATICPERL/patched"
337
309 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 338 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
310 rm -rf "$PERL_PREFIX" # by this rm -rf 339 rm -rf "$PERL_PREFIX" # by this rm -rf
311 340
312 "$MAKE" install || fatal "make install: error while installing" 341 "$MAKE" install || fatal "make install: error while installing"
313 342
314 rcd "$PERL_PREFIX" 343 rcd "$PERL_PREFIX"
315 344
316 # create a "make install" replacement for CPAN 345 # create a "make install" replacement for CPAN
317 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 346 write_shellscript SP-make-install-make <<'EOF'
318"$MAKE" || exit 347#CAT make-install-make.sh
319
320if find blib/arch/auto -type f | grep -q -v .exists; then
321 echo Probably an XS module, rebuilding perl
322 if "$MAKE" perl; then
323 mv perl "$PERL_PREFIX"/bin/perl~ \
324 && rm -f "$PERL_PREFIX"/bin/perl \
325 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
326 "$MAKE" -f Makefile.aperl map_clean
327 else
328 "$MAKE" -f Makefile.aperl map_clean
329 exit 1
330 fi
331fi
332
333"$MAKE" install UNINST=1
334EOF 348EOF
335 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
336 349
350 # create a "patch modules" helper
351 write_shellscript SP-patch-postinstall <<'EOF'
352#CAT patch-postinstall.sh
353EOF
354
355 "$PERL_PREFIX/bin/SP-patch-postinstall"
356
337 # trick CPAN into avoiding ~/.cpan completely 357 # help to trick CPAN into avoiding ~/.cpan completely
338 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 358 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
339 359
360 # we call cpan with -MCPAN::MyConfig in this script, which
361 # is strictly unnecssary as we have to patch CPAN anyway,
362 # so consider it "for good measure".
340 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 363 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
341 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 364 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
342 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 365 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
343 CPAN::Shell->o (conf => q<init>); 366 CPAN::Shell->o (conf => q<init>);
344 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 367 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
345 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 368 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
346 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 369 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
347 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 370 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
348 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 371 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
349 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 372 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
350 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 373 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
351 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 374 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
375 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
352 CPAN::Shell->o (conf => q<commit>); 376 CPAN::Shell->o (conf => q<commit>);
353 ' || fatal "error while initialising CPAN" 377 ' || fatal "error while initialising CPAN"
354 378
355 touch "$PERL_PREFIX/staticstamp.install" 379 touch "$PERL_PREFIX/staticstamp.install"
356 fi 380 fi
376installing modules from CPAN 400installing modules from CPAN
377$@ 401$@
378EOF 402EOF
379 403
380 for mod in "$@"; do 404 for mod in "$@"; do
381 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 405 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \
382 || fatal "$mod: unable to install from CPAN" 406 || fatal "$mod: unable to install from CPAN"
383 done 407 done
384 rm -rf "$STATICPERL/build" 408 rm -rf "$STATICPERL/build"
385} 409}
386 410
402 rcd $mod 426 rcd $mod
403 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1 427 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
404 "$MAKE" distclean >/dev/null 2>&1 428 "$MAKE" distclean >/dev/null 2>&1
405 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 429 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
406 "$MAKE" || fatal "$mod: error building module" 430 "$MAKE" || fatal "$mod: error building module"
407 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 431 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
408 "$MAKE" distclean >/dev/null 2>&1 432 "$MAKE" distclean >/dev/null 2>&1
409 exit 0 433 exit 0
410 ) || exit $? 434 ) || exit $?
411 done 435 done
412} 436}
444#CAT mkbundle 468#CAT mkbundle
445MKBUNDLE 469MKBUNDLE
446} 470}
447 471
448bundle() { 472bundle() {
473 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
449 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 474 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
450 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 475 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
451 CACHE="$STATICPERL/cache" 476 CACHE="$STATICPERL/cache"
452 mkdir -p "$CACHE" 477 mkdir -p "$CACHE"
453 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 478 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
472 ;; 497 ;;
473 instcpan ) 498 instcpan )
474 ( instcpan "$@" ) || exit 499 ( instcpan "$@" ) || exit
475 exit 500 exit
476 ;; 501 ;;
502 perl )
503 ( install ) || exit
504 exec "$PERL_PREFIX/bin/perl" "$@"
505 exit
506 ;;
477 cpan ) 507 cpan )
478 ( install ) || exit 508 ( install ) || exit
479 "$PERL_PREFIX/bin/cpan" "$@" 509 exec "$PERL_PREFIX/bin/cpan" "$@"
480 exit 510 exit
481 ;; 511 ;;
482 mkbundle ) 512 mkbundle )
483 ( install ) || exit 513 ( install ) || exit
484 bundle "$@" 514 bundle "$@"

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines